unit Crowd3Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin, Mask, Math, ComCtrls;

type
  TFmCrowd3 = class(TForm)
    LoadParamDlg: TOpenDialog;
    SaveParamDlg: TSaveDialog;
    ParamEditPanel: TPanel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    SpinEdit7: TSpinEdit;
    SpinEdit8: TSpinEdit;
    SpinEdit9: TSpinEdit;
    SpinEdit10: TSpinEdit;
    SpinEdit11: TSpinEdit;
    SpinEdit12: TSpinEdit;
    SpinEdit13: TSpinEdit;
    SpinEdit14: TSpinEdit;
    SpinEdit15: TSpinEdit;
    Image1: TImage;
    SpinEdit16: TSpinEdit;
    SeekDestin: TUpDown;
    SeekEd: TEdit;
    ActEdit: TEdit;
    EditParams: TButton;
    CopyExec: TButton;
    CopyPanel: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    EndCopy: TSpinEdit;
    StartCopy: TSpinEdit;
    SetRandom: TCheckBox;
    Label1: TLabel;
    SetPersonNum: TSpinEdit;
    ActInact: TUpDown;
    RunProg: TButton;
    SpinEdit17: TSpinEdit;
    SpinEdit18: TSpinEdit;
    SeekUpDown: TUpDown;
    ClearAll: TButton;
    ExitProg: TButton;
    SaveData: TButton;
    SetTrails: TButton;
    Memo1: TMemo;
    HelpButt: TButton;
    PauseToggle: TButton;
    Memo2: TMemo;
    Label4: TLabel;
    NewFile: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    SetAll: TButton;
    SetNone: TButton;
    SeqPers: TCheckBox;
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure SpinEdit5Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure SpinEdit7Change(Sender: TObject);
    procedure SpinEdit8Change(Sender: TObject);
    procedure SpinEdit9Change(Sender: TObject);
    procedure SpinEdit10Change(Sender: TObject);
    procedure SpinEdit11Change(Sender: TObject);
    procedure SpinEdit12Change(Sender: TObject);
    procedure SpinEdit13Change(Sender: TObject);
    procedure SpinEdit14Change(Sender: TObject);
    procedure SpinEdit15Change(Sender: TObject);
    procedure SpinEdit16Change(Sender: TObject);
    procedure SeekDestinClick(Sender: TObject; Button: TUDBtnType);
    procedure EditParamsClick(Sender: TObject);
    procedure InitCrowd3(Sender: TObject);
    procedure SetPersonNumChange(Sender: TObject);
    procedure SetRandomClick(Sender: TObject);
    procedure StartCopyChange(Sender: TObject);
    procedure EndCopyChange(Sender: TObject);
    procedure CopyExecClick(Sender: TObject);
    procedure ActInactClick(Sender: TObject; Button: TUDBtnType);
    procedure RunProgClick(Sender: TObject);
    procedure SpinEdit17Change(Sender: TObject);
    procedure SpinEdit18Change(Sender: TObject);
    procedure SeekUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ClearAllClick(Sender: TObject);
    procedure ExitProgClick(Sender: TObject);
    procedure SaveDataClick(Sender: TObject);
    procedure SetTrailsClick(Sender: TObject);
    procedure HelpButtClick(Sender: TObject);
    procedure PauseToggleClick(Sender: TObject);
    procedure NewFileClick(Sender: TObject);
    procedure SetAllClick(Sender: TObject);
    procedure SetNoneClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  procedure idleloop(Sender: TObject; var Done: boolean);

  end;

var
  FmCrowd3: TFmCrowd3;

implementation

{$R *.dfm}

const MaxPersons = 256;
      backgrnd = clWhite;
      ParamLegends:
         array[0..19] of string =
                  ( 'InitX..........',
                    'InitY..........',
                    'InitDir........',
                    'AvoidProx.r...',
                    'AvoidProx.g..',
                    'AvoidDir.r....',
                    'AvoidDir.g...',
                    'SeekProx.r....',
                    'SeekProx.g...',
                    'SeekDir.r.....',
                    'SeekDir.g....',
                    'DestProx.r....',
                    'DestProx.g...',
                    'DestDir.r.....',
                    'DestDir.g....',
                    'Seek Pers/Dest.',
                    'SeekPerNum.....',
                    'Active/Inact...',
                    'Destination X..',
                    'Destination Y..');

type PersonRecordType = record
                      InitX,
                      Inity,
                      InitDir: single;
                      AvoidProx: record
                                   p,r,e,g,o:single;
                                  end;
                      AvoidDir: record
                                 p,r,e,g,o:single;
                                end;
                      DestProx: record
                                 p,r,e,g,o:single;
                                 end;
                      DestDir:  record
                                 p,r,e,g,o:single;
                                 end;
                      SeekProx: record
                                 p,r,e,g,o:single;
                                end;
                      SeekDir:  record
                                 p,r,e,g,o:single;
                                end;
                      SeekPD,
                      SeekPerNum,
                      Status: smallint;
                      DestX,DestY,PerX,PerY,PerDir: single;
                     end;

     PersonParamType = array[0..maxpersons - 1] of personrecordtype;

var PP: personparamtype;
    paramfile: file of personparamtype;
    paramfilename: string;
    ButtonHelpOn: boolean;
    Person: smallint;
    Editing, RandomPos, CopyReady, FileClosed: boolean;
    FirstCopyNum, LastCopyNum: smallint;
    radius: smallint;
    x0, y0: smallint;
    Xscale, Yscale: single;
    oldx: array[0..MaxPersons - 1] of integer;
    oldy: array[0..MaxPersons - 1] of integer;
    RelProx,RelDir: Single;
    vel: single;
    hcenter, vcenter: integer;
    LeftP,RightP: single;
    numpersons,Myself,stage: integer;
    trails, running, paramsloaded, pause: boolean;
    t1, t2, freq: int64;


procedure showlegends;
var i: integer;
begin
 with FmCrowd3.image1.canvas do
 begin
  font.name := 'Courier New';
  font.size := 10;
  for i := 0 to 19 do
   textout(1,2+round(24.0*i),paramlegends[i]);
  end;
end;

procedure countpersons;
var i: integer;
begin
 numpersons := 0;
 for i := 0 to maxpersons -1 do
  if PP[i].status <> -1 then inc(numpersons);
end;

procedure showparams(person: integer);
begin
 with FmCrowd3, PP[Person] do
 begin
  spinedit1.value := round(InitX);
  spinedit2.value := round(InitY);
  spinedit3.value := round(180/pi*InitDir);
  spinedit4.value := round(AvoidProx.r);
  spinedit5.value := round(AvoidProx.g);
  spinedit6.value := round(AvoidDir.r);
  spinedit7.value := round(AvoidDir.g);
  spinedit8.value := round(SeekProx.r);
  spinedit9.value := round(SeekProx.g);
  spinedit10.value := round(180/pi*SeekDir.r);
  spinedit11.value := round(SeekDir.g);
  spinedit12.value := round(DestProx.r);
  spinedit13.value := round(DestProx.g);
  spinedit14.value := round(180/pi*DestDir.r);
  spinedit15.value := round(DestDir.g);
  spinedit16.value := SeekPerNum;
  spinedit17.value := round(DestX);
  spinedit18.value := round(DestY);
  case seekpd of
   0: seekEd.Text := 'None';
   1: seekEd.Text := 'Dest''n';
   2: seekEd.Text := 'Person';
  end;
  seekupdown.position := seekpd;
  case status of
   -1: Actedit.text := 'Unused';
    0: Actedit.text := 'Inactive';
    1: Actedit.text := 'Active';
  end;
 FMCrowd3.ActInact.position := status + 1;
 end;
end;


procedure LoadDefaultParams;
begin
 Person := 0;
 with PP[Person] do
  begin
    InitX := -450.0;
    InitY := 100.0;
    InitDir := 0.0;
    AvoidProx.r := 100.0;
    AvoidProx.g  := 60.0;
    AvoidDir.r := 100.0;
    AvoidDir.g := 25.0;
    DestProx.r := 250.0;
    DestProx.g := 15.0;
    DestDir.r:= 0.0;
    DestDir.g := 100;
    SeekProx.r := 0.0;
    SeekProx.g := 0.0;
    SeekDir.r := 0.0;
    SeekDir.g := 0.0;
    SeekPD := 1;
    SeekPerNum := 0;
    Status := 1;
    DestX := 450.0;
    DestY := -350.0;
   end;
end;


procedure LoadParams;
var i,p: integer;
    goodfile: boolean;
begin
 with FmCrowd3,LoadParamDlg do
 begin
  InitialDir := GetCurrentDir;
  goodfile := execute;
  if goodfile then
  begin
   paramfilename := filename;
   p := pos('.',paramfilename);
   if p > 0 then
     delete(paramfilename,p,length(paramfilename) - p + 1);
   paramfilename := paramfilename + '.per';
   filename := paramfilename;
   assignfile(paramfile,paramfilename);
   {$I-}
   reset(paramfile);
   {$I+}
   goodfile := (IOresult = 0) and (not EOF(paramfile));
   if goodfile then
    begin
     {$i-}
     read(paramfile,PP);
     {$i+}
     p := IOresult;
     if p <> 0 then
     closefile(paramfile);
     delete(paramfilename,1,length(InitialDir)+1);
     p := pos('.',paramfilename);
     if p > 0 then
     delete(paramfilename,p,length(paramfilename) - p + 1);
    Label4.Font.Size := -12;
    Label4.caption := UpperCase(paramfilename);
    end;
  end;
  if not goodfile then
   begin
    LoadDefaultParams;
    for i := 1 to 255 do PP[i].status := -1;
   end;
 Person := 0;
 SetPersonNum.value := Person;
 end;
 fileclosed := false;
 Showlegends;
 paramsloaded := true;
 showparams(Person);
 countpersons;
end;

procedure initrun;
var i,x,y: integer;
begin
 with FmCrowd3,Canvas do
 begin
  x0 := 80;
  y0 := 0;
  xscale := (clientwidth - x0)/1000.0;
  yscale := (clientheight - y0)/800.0;
  hcenter := x0 + (clientwidth - x0) div 2;
  vcenter := y0 + (clientheight - y0) div 2;
  brush.color := clwhite;
  fillrect(rect(x0, y0,x0 + round(1000*xscale),y0 + round(800*yscale)));
  pen.Width := 2;
  radius := 5;
  i := 0;
  while (i < 256) do
  with PP[i] do
  begin
   if (Status = 0) then // In use but inactive
    begin
     InitX:=  random(600) - 300;
     InitY := random(500) - 250;
     PerX := InitX;
     PerY := InitY;
     x := hcenter + round(Xscale*PerX);
     y := vcenter - round(Yscale*perY);
     pen.color := clBlack;
     ellipse(rect(x - radius, y - radius,
             x + radius, y + radius));
    end
   else
   if status = 1 then // active person
   begin
    PerX := InitX;
    PerY := InitY;
    PerDir := InitDir;
    oldx[i] := round(Xscale*InitX);
    oldy[i] := round(YScale*InitY);
   end;
  inc(i);
  end;
 end;
 stage := 0;
end;

{ -------------------------------------------------------------------------}

procedure saveparams;
var p: integer;
    goodfile: boolean;
begin
 with FmCrowd3,SaveParamDlg do
 begin
  InitialDir := GetCurrentDir;
  goodfile := execute;
  if goodfile then
  begin
   paramfilename := filename;
   p := pos('.',paramfilename);
   if p > 0 then
     delete(paramfilename,p,length(paramfilename) - p + 1);
   paramfilename := paramfilename + '.per';
   filename := paramfilename;
   assignfile(paramfile,paramfilename);
   {$I-}
   rewrite(paramfile);
   {$I+}
   goodfile := (IOresult = 0);
   if goodfile then
    begin
     write(paramfile,PP);
     closefile(paramfile);
    end;
  end;
 end;
 initrun;
end;

{ -------------------------------------------------------------------------}

function proxfunc(p,proxfactor: single): single;
begin
 proxfunc := 255.0*proxfactor/(proxfactor + sqr(p));
end;

{ -------------------------------------------------------------------------}

// Returns distance and angle as single
procedure FindRhoTheta(var distance,angle: single;
                       x1,y1,x2,y2: single;
                       Myself: smallint);
var x,y: single;
begin
 x := x2 - x1; y := y2 - y1;
 angle := arctan2(y,x); // angle in radians, 0 to 2pi
 distance := sqrt(sqr(x) + sqr(y));
end;

{ -------------------------------------------------------------------------}
{           THIS LOOP REPEATS RUNS AND ALLOWS PARAMETER CHANGES            }
{ -------------------------------------------------------------------------}

procedure runloop;
var x,y,r,i,j: integer;
    d,temp: single;
    colorcircle: Tcolor;
begin
 j := 0;
 while (j < 255)  do
 with PP[j] do
 begin
  with FmCrowd3.Canvas do
  case seekPD of
   1: colorcircle := clRed;
   2: colorcircle := rgb(0,200,100);
   else colorcircle := clBlack;
  end;
  if status = 1 then
  begin
   Myself := j;
   FindRhoTheta(DestProx.p,DestDir.p,
                PerX,PerY,DestX,DestY,
                Myself);
   if DestProx.p < 255 then   // destprox is a temporary variable here
    DestProx.p := ProxFunc(Destprox.p,200)
   else DestProx.p := 0;
   temp := DestDir.p - PerDir;
   while temp <= -pi do temp := temp + 2*pi;
   while temp > pi do temp := temp - 2*pi;
   PP[j].DestDir.p := temp;   //Dest angle relative to travel angle
   LeftP := 0;
   RightP := 0;
   for i := 0 to Maxpersons - 1 do
    if (i <> Myself) and (PP[i].status <> -1) then
    begin
     findRhoTheta(RelProx,RelDir,
                  PP[Myself].PerX,PP[Myself].PerY,
                  PP[i].PerX,PP[i].PerY,Myself);
     d := RelProx - radius - radius; if d < 0.0 then d := 0.0;
     RelDir := RelDir - PerDir;  // dist and direction to obstacle
     while RelDir <= -pi do RelDir := RelDir + 2*pi;
     while RelDir > pi do RelDir := RelDir - 2*pi;
     temp := cos(Reldir/4);
     if temp < 0 then temp := 0.0;
     if (RelDir <= 0) then
       RightP := RightP + proxfunc(d,200)*cos(temp)
     else if (RelDir > 0) then
       LeftP := LeftP + ProxFunc(d,200)*Cos(temp);
    end;
    LeftP := 100*LeftP/numpersons;
    RightP :=100*RightP/numpersons;

    if LeftP < 0.0 then LeftP := 0.0;
    if RightP < 0.0 then RightP := 0.0;

   with AvoidProx do
    begin
     p := RightP + LeftP;
     e := r - p;
     if e < 0 then o := 0.0001*g*e else o := -0.0;
    end;

   with AvoidDir do
    begin
     p := RightP + LeftP;
     e := r - p;
     if e > 0 then e := 0;
     if RightP > LeftP then e := -e;
     o := 0.001*g*e + 0.3*(random - 0.5);
    end;

   // Routines for seeking another person's position
   if SeekPD = 2 then
   begin
     FindRhoTheta(temp,RelDir,PerX,PerY,
                  PP[SeekPerNum].PerX,
                  PP[SeekPerNum].PerY,Myself);
    RelProx := 100*ProxFunc(Temp,10);
    RelDir := RelDir - PerDir;
    while RelDir <= -pi do RelDir := RelDir + 2*pi;
    while RelDir > pi do RelDir := RelDir - 2*pi;

    with SeekProx do
    begin
     p := RelProx;
     e := r - p;
     o := 0.01*g*e;
    end;

    with SeekDir do
    begin
     p := RelDir;
     e := r - p;
     while e > pi do e := e - 2*pi;
     while e < -pi do e := e + 2*pi;
     o := -0.02*g*e;
    end;
   end;

   with DestDir do
   begin
    e := r - p;
    while e > pi do e := e - 2*pi;
    while e < -pi do e := e + 2*pi;
    o :=  -0.05*g*e;
   end;

   with DestProx do
   begin
    e := r - p;
    o := 0.01*g*e;
   end;

   PerDir :=  PerDir + 0.05*(DestDir.o + AvoidDir.o + SeekDir.o);
   while PerDir > 2*pi do PerDir := PerDir - 2*pi;
   while PerDir < -2*pi do PerDir := PerDir + 2*pi;


   Vel := 0.1*(DestProx.o + 10*AvoidProx.o + SeekProx.o);
   if Vel < 0 then vel := 0.0;

   // COMPUTE CONTROL OUTPUTS AND PLOT POSITIONS
   with FmCrowd3, canvas do
    begin
     pen.color := clRed;   // rewrite destination circle
     x := hcenter + round(Xscale*DestX);
     y := vcenter - round(Yscale*DestY);
     if PP[j].seekPD = 1 then
      ellipse(rect(x - 10, y - 10, x + 10, y + 10));
     pen.Color := backgrnd;
     ellipse(rect(oldx[j] - radius, oldy[j] - radius,
                  oldx[j] + radius, oldy[j] + radius)); //erase
     PerX := PerX + Vel*cos(PerDir);
     PerY := PerY + Vel*sin(PerDir);
     oldx[j] := hcenter + round(Xscale*PerX);
     oldy[j] := vcenter - round(Yscale*PerY);
     pen.color := colorcircle;
     ellipse(rect(oldx[j] - radius,oldy[j] - radius,
                  oldx[j] + radius,oldy[j] + radius));
     if trails then
      begin
       x := hcenter + round(Xscale*(PerX - 2*radius*cos(PerDir)));
       y := vcenter - round(Yscale*(PerY - 2*radius*sin(PerDir)));
       ellipse(rect(x-1,y-1, x+1, y+1));
      end;
    end;
  end;
  inc(j);
 end;
end;

procedure iterate;
begin
 case stage of
  0: if not paramsloaded then
   begin
    loadparams;
    initrun;
   end;
  1: if not pause then runloop;
 end;
end;

procedure TfmCrowd3.idleloop(Sender: TObject; var Done: boolean);
begin
 done := false;
 iterate;
 repeat
  queryperformancecounter(t2);
 until (t2 - t1) >= freq/30;
 t1 := t2;
end;

{$R-}
function editnumok(s:string): boolean;
var t,code: integer;
begin
 val(s,t,code);
 editnumok := code = 0;
end;

procedure TFmCrowd3.SpinEdit1Change(Sender: TObject);
begin
 if not editnumok(spinedit1.text) then exit;
  PP[Person].InitX := SpinEdit1.Value;
end;

procedure TFmCrowd3.SpinEdit2Change(Sender: TObject);
begin
 if not editnumok(SpinEdit2.text) then exit;
 With PP[Person] do
  InitY := SpinEdit2.Value;
end;

procedure TFmCrowd3.SpinEdit3Change(Sender: TObject);
begin
  if not editnumok(SpinEdit3.text) then exit;
   With PP[Person] do
  InitDir := pi/180.0*SpinEdit3.Value;
end;

procedure TFmCrowd3.SpinEdit4Change(Sender: TObject);
begin
 if not editnumok(SpinEdit4.text) then exit;
   With PP[Person] do
    AvoidProx.r := SpinEdit4.Value;
end;

procedure TFmCrowd3.SpinEdit5Change(Sender: TObject);
begin
 if not editnumok(SpinEdit5.text) then exit;
   With PP[Person] do
    AvoidProx.g := SpinEdit5.Value;
end;

procedure TFmCrowd3.SpinEdit6Change(Sender: TObject);
begin
 if not editnumok(SpinEdit6.text) then exit;
   With PP[Person] do
    AvoidDir.r := SpinEdit6.Value;
end;

procedure TFmCrowd3.SpinEdit7Change(Sender: TObject);
begin
 if not editnumok(SpinEdit7.text) then exit;
   With PP[Person] do
    AvoidDir.g := SpinEdit7.Value;
end;

procedure TFmCrowd3.SpinEdit8Change(Sender: TObject);
begin
 if not editnumok(SpinEdit8.text) then exit;
 With PP[Person] do
  SeekProx.r := SpinEdit8.Value;
end;

procedure TFmCrowd3.SpinEdit9Change(Sender: TObject);
begin
 if not editnumok(SpinEdit9.text) then exit;
 With PP[Person] do
  SeekProx.g := SpinEdit9.Value;
end;

procedure TFmCrowd3.SpinEdit10Change(Sender: TObject);
begin
 if not editnumok(SpinEdit10.text) then exit;
 With PP[Person] do
  SeekDir.r := pi/180.0*SpinEdit10.Value;
end;

procedure TFmCrowd3.SpinEdit11Change(Sender: TObject);
begin
 if not editnumok(SpinEdit11.text) then exit;
 With PP[Person] do
  SeekDir.g := SpinEdit11.Value;
end;

procedure TFmCrowd3.SpinEdit12Change(Sender: TObject);
begin
 if not editnumok(SpinEdit12.text) then exit;
 With PP[Person] do
  DestProx.r := SpinEdit12.Value;
end;

procedure TFmCrowd3.SpinEdit13Change(Sender: TObject);
begin
 if not editnumok(SpinEdit13.text) then exit;
 With PP[Person] do
  DestProx.g := SpinEdit13.Value;
end;

procedure TFmCrowd3.SpinEdit14Change(Sender: TObject);
begin
 if not editnumok(SpinEdit14.text) then exit;
 With PP[Person] do
  DestDir.r := pi/180.0*SpinEdit14.Value;
end;

procedure TFmCrowd3.SpinEdit15Change(Sender: TObject);
begin
 if not editnumok(SpinEdit15.text) then exit;
 With PP[Person] do
  DestDir.g := SpinEdit15.Value;
end;

procedure TFmCrowd3.SpinEdit16Change(Sender: TObject);
begin
 if not editnumok(SpinEdit16.text) then exit;
 With PP[Person] do
  SeekPerNum := SpinEdit16.Value;
end;

procedure TFmCrowd3.SpinEdit17Change(Sender: TObject);
begin
 if not editnumok(SpinEdit17.text) then exit;
 PP[person].DestX := SpinEdit17.Value;
end;

procedure TFmCrowd3.SpinEdit18Change(Sender: TObject);
begin
 if not editnumok(SpinEdit18.text) then exit;
 PP[person].DestY := SpinEdit18.Value;
end;

procedure TFmCrowd3.SeekDestinClick(Sender: TObject; Button: TUDBtnType);
begin
 with FmCrowd3 do
 case SeekDestin.position of
  0: begin
      SeekEd.text := 'None';
      PP[Person].SeekPD := 0;
     end;
  1: begin
      SeekEd.text := 'Dest''n';
      PP[Person].SeekPD := 1;
     end;
  2: begin
      SeekEd.text := 'Person';
      PP[Person].SeekPD := 2;
     end;
 end;
end;

procedure endediting;
begin
 with FmCrowd3,editparams do
 begin
   FmCrowd3.EditParams.Caption := 'EDIT PAR';
   brush.color := backgrnd;
   stage := 0;
   FmCrowd3.ParamEditPanel.visible := false;
   initrun;
   countpersons;
   memo2.Lines.SaveToFile('Editing.txt');
 end;
end;

procedure TFmCrowd3.EditParamsClick(Sender: TObject);
begin
 Editing := not Editing;
 memo2.Visible := Editing;
 if not Editing then
  begin
   EndEditing;
  end
 else
  begin
   Showparams(person);
   EditParams.Caption := 'END EDIT';
  end;
 ParamEditPanel.visible := Editing;
end;

procedure TFmCrowd3.InitCrowd3(Sender: TObject);
begin
 with FmCrowd3 do
  begin
   ParamEditPanel.visible := false;
   Copypanel.visible := false;
  end;
 copyready := false;
 running := false;
 stage := 0;
 paramsloaded := false;
 memo1.Lines.loadfromfile('buttons.txt');
 memo2.Lines.LoadFromFile('Editing.txt');
 memo1.Visible := false;
 memo2.visible := false;
 randomize;
 queryPerformanceFrequency(Freq);
 queryPerformanceCounter(t1);
 application.OnIdle := idleloop;
end;

procedure TFmCrowd3.SetPersonNumChange(Sender: TObject);
begin
 if not editnumok(SetPersonNum.text) then exit;
 Person := SetPersonNum.value;
 showparams(person);
end;

procedure TFmCrowd3.SetRandomClick(Sender: TObject);
begin
 RandomPos := setrandom.Checked;
end;

procedure TFmCrowd3.StartCopyChange(Sender: TObject);
begin
 if not editnumok(StartCopy.text) then exit;
  FirstCopyNum := StartCopy.value;
end;

procedure TFmCrowd3.EndCopyChange(Sender: TObject);
begin
 if not editnumok(EndCopy.text) then exit;
 LastCopyNum := EndCopy.value;
end;

procedure executecopy;
var i: integer;
begin
 if (FirstCopyNum <= LastCopyNum) and
    (LastCopyNum <= maxpersons - 1) then
 for i := FirstCopyNum to LastCopyNum do
  with FmCrowd3 do
  with pp[Person] do
  begin
    if randompos then
    begin
     pp[i].InitX := InitX + random(200) - 100;
     pp[i].InitY := InitY + random(200) - 100;
    end
    else
    begin
     if Checkbox1.Checked then pp[i].InitX := InitX;
     if checkbox2.Checked then pp[i].InitY := InitY;
    end;
    if checkbox3.Checked then pp[i].InitDir := InitDir;;
    if checkbox4.Checked then pp[i].AvoidProx.r := AvoidProx.r;
    if checkbox5.Checked then pp[i].AvoidProx.g := AvoidProx.g;
    if checkbox6.Checked then pp[i].AvoidDir.r := AvoidDir.r;
    if checkbox7.Checked then pp[i].AvoidDir.g := AvoidDir.g;
    if checkbox8.Checked then pp[i].SeekProx.r := SeekProx.r;
    if checkbox9.Checked then pp[i].SeekProx.g := SeekProx.g;
    if checkbox10.Checked then pp[i].SeekDir.r := SeekDir.r;
    if checkbox11.Checked then pp[i].SeekDir.g := SeekDir.g;
    if checkbox12.Checked then pp[i].DestProx.r := DestProx.r;
    if checkbox13.Checked then pp[i].DestProx.g := DestProx.g;
    if checkbox14.Checked then pp[i].DestDir.r := DestDir.r;
    if checkbox15.Checked then pp[i].DestDir.g:= DestDir.g;
    if checkbox16.Checked then pp[i].SeekPD := SeekPD;
    if (FMcrowd3.SeqPers.checked) and
       (pp[i].SeekPD = 2) then
      PP[i].SeekPerNum := i - 1
    else
     if checkbox17.Checked then
      pp[i].SeekPerNum := SeekPerNum;
    if checkbox18.Checked then pp[i].Status :=  Status;
    if checkbox19.Checked then pp[i].DestX := DestX;
    if checkbox20.Checked then pp[i].DestY := DestY;
  end;
end;


procedure TFmCrowd3.CopyExecClick(Sender: TObject);
begin
 CopyReady := not CopyReady;
 if Copyready then
  CopyExec.Caption := 'EXEC COPY';
 Copypanel.visible := CopyReady;
 if Not CopyReady then
  begin
   executecopy;
   CopyExec.Caption := 'SET COPY';
  end;
end;

procedure TFmCrowd3.ActInactClick(Sender: TObject; Button: TUDBtnType);
begin
 case FMCrowd3.ActInact.position of
  0: begin
      Actedit.text := 'Unused';
      PP[Person].Status := -1;
     end;
  1: begin
      Actedit.text := 'Inactive';
      PP[Person].Status := 0;
     end;
  2: begin
      Actedit.text := 'Active';
      PP[Person].Status := 1;
     end;
 end;

end;

procedure TFmCrowd3.RunProgClick(Sender: TObject);
begin
if editing then endediting;
  initrun;
  stage := 1;
end;

procedure TFmCrowd3.SeekUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 with PP[person] do
  seekPD := seekupdown.position ;
 case seekupdown.position of
   0: seekEd.Text := 'None';
   1: seekEd.Text := 'Dest''n';
   2: seekEd.Text := 'Person';
 end;
end;

procedure TFmCrowd3.ClearAllClick(Sender: TObject);
var i: integer;
begin
 for i := person+1 to 255 do
 begin
  fillchar(PP[i],sizeof(PP[i]),0);
  with PP[i] do
   begin
    status := -1;
    SeekPD := 0;
   end;
 end;
 SetPersonNum.value := Person;
 showparams(person);
end;

procedure TFmCrowd3.ExitProgClick(Sender: TObject);
begin
 application.terminate;
end;

procedure TFmCrowd3.SaveDataClick(Sender: TObject);
begin
 Saveparams;
end;

procedure TFmCrowd3.SetTrailsClick(Sender: TObject);
begin
 trails := not trails;
 if not trails then
  settrails.caption := 'Trails Off'
  else settrails.caption := 'Trails On';
end;


procedure TFmCrowd3.HelpButtClick(Sender: TObject);
begin
 ButtonHelpOn := not ButtonHelpOn;
 if not ButtonHelpOn then
  memo1.lines.savetofile('Buttons.txt');
 memo1.Visible := ButtonHelpOn;
 If not ButtonHelpOn then initrun;
end;

procedure TFmCrowd3.PauseToggleClick(Sender: TObject);
begin
 pause := not pause;
 if pause then pausetoggle.caption := 'CONTINUE'
 ELSE pausetoggle.caption := 'PAUSE'
end;

procedure TFmCrowd3.NewFileClick(Sender: TObject);
begin
 paramsloaded := false;
 stage := 0;
end;

procedure TFmCrowd3.SetAllClick(Sender: TObject);
begin
 checkbox1.checked := true;
 checkbox2.checked := true;
 checkbox3.checked := true;
 checkbox4.checked := true;
 checkbox5.checked := true;
 checkbox6.checked := true;
 checkbox7.checked := true;
 checkbox8.checked := true;
 checkbox9.checked := true;
 checkbox10.checked := true;
 checkbox11.checked := true;
 checkbox12.checked := true;
 checkbox13.checked := true;
 checkbox14.checked := true;
 checkbox15.checked := true;
 checkbox16.checked := true;
 checkbox17.checked := true;
 checkbox18.checked := true;
 checkbox19.checked := true;
 checkbox20.checked := true;
end;

procedure TFmCrowd3.SetNoneClick(Sender: TObject);
begin
 checkbox1.checked := false;
 checkbox2.checked := false;
 checkbox3.checked := false;
 checkbox4.checked := false;
 checkbox5.checked := false;
 checkbox6.checked := false;
 checkbox7.checked := false;
 checkbox8.checked := false;
 checkbox9.checked := false;
 checkbox10.checked := false;
 checkbox11.checked := false;
 checkbox12.checked := false;
 checkbox13.checked := false;
 checkbox14.checked := false;
 checkbox15.checked := false;
 checkbox16.checked := false;
 checkbox17.checked := false;
 checkbox18.checked := false;
 checkbox19.checked := false;
 checkbox20.checked := false;
end;



end.
